/*
Plugin Name: Gallery from files
Plugin URI:  http://dovi42.hu/gallery-from-files
Description: Show gallery from file system.
Version:     0.05
Author:      Dovi
Author URI:  http://dovi42.hu/
License:     GPLv2 or later
License URI: https://www.gnu.org/licenses/gpl-2.0.html
Text Domain: gallery-from-files
Generator:   WP Creator - http://wpcreator.hu - 2020-02-28 16:07:00
*/

var gallery_block_counter = 0;

jQuery(document).ready(function() {

    jQuery('[data-fancybox]').fancybox({
        caption : function( instance, item ) {
            var caption = jQuery(this).data('caption') || '';
            if ( item.type === 'image'  && caption != '') {
              caption = '<div class="fancybox-theme-caption">' + caption + '</div>' ;
            }
            return caption;
          }           
    });

	jQuery('ul.gallery-from-files').each(function(){

        var id = jQuery(this).attr('id');
        gallery_from_files_595_setGalleryMargins(id);

	});
});

jQuery( window ).on('resize', function(){
    jQuery('.gallery-from-files').each(function(){
        var id = jQuery(this).attr('id');
        gallery_from_files_595_resetGalleryMargins(id);
    });
});

function gallery_from_files_595_resetGalleryMargins(id) {

    var gallery = jQuery('#'+id);
    var token   = jQuery('#'+id).attr('data-token');

	gallery.find('.clearfix').remove();
    gallery.find('li').each(function(){
        jQuery(this).removeClass( jQuery(this).attr('data-class') );
        jQuery(this).removeAttr('data-class');
        jQuery(this).css('margin-right', '0px');    
	});
    gallery_from_files_595_setGalleryMargins(id);
}


function gallery_from_files_595_setGalleryMargins(id) {

    var gallery = jQuery('#'+id);
    var token   = jQuery('#'+id).attr('data-token') + gallery_block_counter;
    gallery_block_counter++;
    
    var line = 1;
    var w = gallery.innerWidth();
    var line_width = 0;
    var cnt = 0;
    var margin = 0;
    
    gallery.find('.gallery-from-files-item').each(function(){
        var img_w = jQuery(this).outerWidth();
        
        if ((line_width + img_w) < w) {
            line_width = line_width + img_w;
            jQuery(this).addClass(token + '-line-' + line);
            jQuery(this).attr('data-class', token + '-line-' + line);
            cnt++; 
        } else {
            cnt--;
            margin = Math.floor((w - line_width) / cnt);
            jQuery('.'+token + '-line-' + line).css('margin-right', margin + 'px');
            jQuery('.'+token + '-line-' + line + ':last').css('margin-right', '0px');
            line++;
            jQuery('<div class="clearfix" style="clear:both;"></div>').insertBefore(this);
            jQuery(this).addClass(token + '-line-' + line);
            jQuery(this).attr('data-class', token + '-line-' + line);
            cnt = 1;
            line_width = img_w;
        }                
    });    
    cnt--;
    var margin2 = Math.floor((w - line_width) / cnt);
    if (margin2 < margin) { margin = margin2; }
    if (margin == 0) { margin = margin2; }
    jQuery('.'+token + '-line-' + line).css('margin-right', margin + 'px');
    jQuery('.'+token + '-line-' + line + ':last').css('margin-right', '0px');
}

function gallery_from_files_595_get_page(page, item) {
    console.log(item);
    var id     = item.closest('ul.gallery-from-files-pagination').attr('data-id');
    var token  = item.closest('ul.gallery-from-files-pagination').attr('data-token');
    var type   = item.closest('ul.gallery-from-files-pagination').attr('data-type');
    var actual = item.closest('ul.gallery-from-files-pagination').attr('data-actual');
    
    if (actual != page) {
      item.closest('ul.gallery-from-files-pagination').find('.gallery-from-files-page-link').removeClass('current');
      
      //dovi_wpgallery_showImages(token, id); 
      gallery_from_files_595_get_images_page(page, id, token, type);
      
      item.closest('ul.gallery-from-files-pagination').attr('data-actual', page);
      item.closest('li').find('.gallery-from-files-page-link').addClass('current');
      // jQuery('#'+token+'_gallery_pagination_item_'+id).addClass('current');  
    } 
}

function gallery_from_files_595_get_images_page(page, id, token, type) {

    var wait = '<div class="gallery-wait"'+
               ' style="height:'+jQuery('#'+id).height()+'px;'+
               ' width:'+jQuery('#'+id).width()+'px;">'+
               '</div>';
    jQuery('#'+id).prepend(wait);
    jQuery('.gallery-wait').animate({opacity: .3}, 500);
    
    var variables = eval('gallery_from_files_variables_' + token);
    var data = {
            action    : 'gallery_from_files_595_get_images_page',
            variables : variables,
            page      : page,
            id        : id,
            type      : type
        };
    jQuery.ajax({
        url      : gallery_from_files_595_ajax_object.ajax_url,
        dataType : 'json',
        type     : 'POST',
        data     : data,
        success  : function(data, result){
            if (data.status == 1) {
                // Status OK
                jQuery('#'+id).find('.gallery-from-files-item').remove();
                jQuery('#'+id).prepend(data.html);
                gallery_from_files_595_resetGalleryMargins(id);
                jQuery('.gallery-wait').animate({opacity: 0}, 500);
                setTimeout(function(){ 
                    jQuery('.gallery-wait').remove(); 
                }, 500);
            } else {
                console.log(data);
            }
        },
        error: function (request, status, error) {
            alert('AJAX error : ' + status);
        } 
    });
}

function gallery_from_files_595_call_ajax_sample(token, data) {

    var data = {
            action : 'gallery_from_files_595_call_ajax_function',
            variables : data,
            token     : token
        };

    jQuery.ajax({
        url      : gallery_from_files_595_ajax_object.ajax_url,
        dataType : 'json',
        type     : 'POST',
        data     : data,
        success  : function(data, result){
            if (data.status == 1) {
                // Status OK
                jQuery('#gallery_from_files_'+data.token).html(data.html);
            } else {
                console.log(data);
            }
        },
        error: function (request, status, error) {
            alert('AJAX error : ' + status);
        } 
    });
}