<?php
/*
Plugin Name: Gallery from files
Plugin URI:  http://wpdemo.dovi42.hu/gallery-from-files-en/
Description: Show gallery from file system.
Version:     1.30
Author:      Dovi42
Author URI:  http://dovi42.hu/
License:     GPLv2 or later
License URI: https://www.gnu.org/licenses/gpl-2.0.html
Text Domain: gallery-from-files
Generator:   WP Creator - http://wpcreator.hu - 2020-02-28 16:07:00
*/

if ( !defined( 'ABSPATH' ) ) exit;

if (!defined('DS')) {
    define( 'DS', DIRECTORY_SEPARATOR );
}

define('GALLERY_FROM_FILES_595_ROOT', dirname(__FILE__));

function gallery_from_files_595_get_options() { 
	// Alapértelmezett értékek beállítása
	// Set default option values
	$defaults = array(
			'size'       => '800x600',
			'auto'       => '1',
            'th_size'    => '200x200',
			'th_folder'  => '_thumbs',
			'page_limit' => 24,
			'order'      => 'set',
			'fancy'      => '1',
			'title'      => '1',
			'template'   => 'default',
			'watermark'  => '',
			'webp'       => '1', 
            'compress'   => 90,
            'folder'     => ''
		);

	// Beállított értékek beolvasása
	// Get the set plugin option values
	$options = get_option('gallery_from_files_options');

	// Ha nincs beállítva, akkor az alapértelmezett érték 
	// If not set then set the default 
	$options = wp_parse_args($options, $defaults);

	return $options;
}


function gallery_from_files_595_load_textdomain() {
    load_plugin_textdomain( 'gallery-from-files', false, basename( GALLERY_FROM_FILES_595_ROOT ) . '/languages' ); 
}
add_action( 'plugins_loaded', 'gallery_from_files_595_load_textdomain' );

// Show notice 
// Üzenet megjelenítése
function gallery_from_files_595_notices() {
    if( get_transient( 'gallery_from_files_595_activation_notice' ) ) {
        echo '<div class="notice notice-success"><p>' . __('Activation notice', 'gallery-from-files') . '</p></div>';
        delete_transient( 'gallery_from_files_595_activation_notice' );
    }
    if( get_transient( 'gallery_from_files_595_upgrade_notice' ) ) {
        echo '<div class="notice notice-success"><p>' . get_transient( 'gallery_from_files_595_upgrade_notice' ) . '</p></div>';
        delete_transient( 'gallery_from_files_595_upgrade_notice' );
    }
}
add_action( 'admin_notices', 'gallery_from_files_595_notices' );


function gallery_from_files_595_activation() {
    // A plugin aktiválásakor fut le
    // Call when plugin is activated
    
	// Alapértelmezett értékek beállítása
	// Set default value(s) to options
	$options = gallery_from_files_595_get_options();
	update_option('gallery_from_files_options', $options, true);
    
    add_action( 'admin_notices', 'gallery_from_files_595_activation_notice' );
    set_transient( 'gallery_from_files_595_activation_notice', 1 );
    
    // flush_rewrite_rules();
}
register_activation_hook( __file__, 'gallery_from_files_595_activation' );

function gallery_from_files_595_deactivation() {
    // A plugin deaktiválásakor fut le
    // Call when plugin is deactivated

	// Beállítások törlése
	// Delete value(s) from options
	delete_option('gallery_from_files_options');

    // flush_rewrite_rules();
}
register_deactivation_hook( __file__, 'gallery_from_files_595_deactivation' );

function gallery_from_files_595_uninstall() {
    // A plugin törlésekor fut le
    // Call when plugin is uninstall

}
register_uninstall_hook( __file__, 'gallery_from_files_595_uninstall' );

function gallery_from_files_595_upgrade_completed( $upgrader_object, $options ) {
    $our_plugin = plugin_basename( __file__ );
    if( $options['action'] == 'update' && $options['type'] == 'plugin' && isset( $options['plugins'] ) ) {
        foreach( $options['plugins'] as $plugin ) {
            if( $plugin == $our_plugin ) {

                $error = false;
                                
                // Ide kerülnek a frissítés utáni feladatok
                // Here are the post-upgrade features

                // Fontos! Frissítéskor még nem az új nyelvi fájlok vannak használatban! 
                // Important! New language files are not in use when updating!
                
                if ($error) {
                    $error_info = __('Update error notice', 'gallery-from-files');
                    
                    // $error_info .= '<br />' . 'Frissítési hibaüzenet';
                    // $error_info .= '<br />' . 'The exact error';
                    
                    set_transient( 'gallery_from_files_595_upgrade_notice', $error_info );
                } else {
                    
                    $ok_info = __('Update ok notice', 'gallery-from-files');
                    $lang = get_bloginfo('language');
                    if ($lang == 'hu') {
                        $ok_info .= '<br />' . 
                                    'Átdolgozott sablon kezelés, WebP támogatás';
                    } else {
                        $ok_info .= '<br />' . 
                                    'Revamped template management, WebP support';
                    }
                    
                    set_transient( 'gallery_from_files_595_upgrade_notice', $ok_info );
                }
            }
        }
    }
}
add_action( 'upgrader_process_complete', 'gallery_from_files_595_upgrade_completed', 10, 2 );


function gallery_from_files_595_shortcode($args) {

	// Alapértelmezett értékek betöltése
	// Load default option values
	$options = gallery_from_files_595_get_options();
    $args = wp_parse_args($args, $options);

	// Elviekben lehetséges többszöri meghívás, ezért a jelző csak egyszer engedi betölteni a szkripteket.
	// In principle, multiple invitations are possible, so the token will only allow you to load scripts once.
	if (!defined('GALLERY_FROM_FILES_595')) {
		// A globális beállítások átadódnak a script-ek meghívásához
		// Global settings are passed to invite scripts
		gallery_from_files_595_styles_and_scripts_to_frontend();
	}

    // Osztály betöltése, ha kell
    // Load class if needed
    if (!class_exists('JGalleryFromFiles595')) {
        include_once( GALLERY_FROM_FILES_595_ROOT .DS. 'libs' .DS. 'class.php');
    }

    // Az alapértelmezett paraméterekkel történik az optiomalizálás
    // Init to default options
    $my_plugin = new JGalleryFromFiles595($args);

    $html = $my_plugin->prepareContent();
    
    return $html;
}
add_shortcode('gallery-from-files', 'gallery_from_files_595_shortcode');


function gallery_from_files_595_styles_and_scripts_to_frontend()
{
    global $pagenow;

    define('GALLERY_FROM_FILES_595', 1);

    // Csak a felhasználói oldalon töltődjenek be a szkriptek
    // Only load scripts on the user page
    if (in_array( $pagenow, array( 'post.php', 'page.php', 'index.php' ))) {

        wp_register_style( 'gallery-from-files', plugins_url( 'assets/css/gallery-from-files.css', __file__ ) );
    	wp_enqueue_style( 'gallery-from-files' );
        
    	wp_register_script('gallery-from-files-js', plugins_url( 'assets/js/gallery-from-files.js', __file__ ), array('jquery'), false, true);

        $options = gallery_from_files_595_get_options();
        if ((isset($options['fancy'])) and ($options['fancy'] == 1)) {
    
            wp_register_style( 'gallery-from-files-fancybox-css', plugins_url( 'assets/css/fancybox.min.css', __file__ ) );
        	wp_enqueue_style(  'gallery-from-files-fancybox-css' );
            wp_register_script('gallery-from-files-fancybox', plugins_url( 'assets/js/fancybox/fancybox.min.js', __file__ ), array('jquery'), false, true);
            wp_enqueue_script( 'gallery-from-files-fancybox');    
        }


		// Ajax hívás engedélyezése
		// Enable call ajax
		wp_localize_script('gallery-from-files-js', 'gallery_from_files_595_ajax_object', array( 'ajax_url' => admin_url( 'admin-ajax.php' ) ) );
		wp_enqueue_script('gallery-from-files-js');
    }
}

if ( is_admin() ){ 

    global $pagenow;

    if (in_array($pagenow, array('post.php', 'post-new.php'))) {
        include_once( GALLERY_FROM_FILES_595_ROOT .DIRECTORY_SEPARATOR. 'libs' .DIRECTORY_SEPARATOR. 'insert-button.php');
    }

    include_once( GALLERY_FROM_FILES_595_ROOT .DS. 'libs' .DS. 'admin-functions.php');
    include_once( GALLERY_FROM_FILES_595_ROOT .DS. 'libs' .DS. 'gallery-from-files-setup.php' );
    $my_settings_page = new gallery_from_files_595_settings();
    
    function gallery_from_files_595_get_extra_meta_links($meta, $file, $data, $status) {

        if (plugin_basename(__FILE__) == $file) {
            $lang = get_bloginfo('language');
            if ($lang == 'hu') {
                $url = 'http://wpdemo.dovi42.hu/gallery-from-files';
            } else {
                $url = 'http://wpdemo.dovi42.hu/gallery-from-files-en';
            } 
            $meta[] = "<a href='".$url."' target='_blank' title='" . __('Detailed description and examples', 'gallery-from-files') . "'>".__('Detailed description and examples', 'gallery-from-files')."</a>";

            $meta[]  = '<a href="https://wordpress.org/support/plugin/gallery-from-files/reviews/">'.
                       __('Please rating!', 'gallery-from-files') . '&nbsp;' .
                       '<span class="dashicons dashicons-star-empty dashicons-star-filled" style="color:#ffb900 !important;"></span>'.
                       '<span class="dashicons dashicons-star-empty dashicons-star-filled" style="color:#ffb900 !important;"></span>'.
                       '<span class="dashicons dashicons-star-empty dashicons-star-filled" style="color:#ffb900 !important;"></span>'.
                       '<span class="dashicons dashicons-star-empty dashicons-star-filled" style="color:#ffb900 !important;"></span>'.
                       '<span class="dashicons dashicons-star-empty dashicons-star-filled" style="color:#ffb900 !important;"></span>'.
                       '</a>';
        }
        return $meta;
    }
    add_filter("plugin_row_meta", 'gallery_from_files_595_get_extra_meta_links', 10, 4);
    

}

// Add settings link to media menu
function gallery_from_files_595_add_custom_link_into_appearnace_menu() {
    global $submenu;
    $permalink = 'options-general.php?page=gallery-from-files-setting-admin&gallery-from-files-tab=galleries';
    $submenu['upload.php'][] = array( __('Gallery from files', 'gallery-from-files'), 'manage_options', $permalink );
}
add_action('admin_menu', 'gallery_from_files_595_add_custom_link_into_appearnace_menu');


// Add settings link to plugins page 
function gallery_from_files_595_add_settings_link( $links ) {
    $settings_link = '<a href="options-general.php?page=gallery-from-files-setting-admin">' . __( 'Settings' ) . '</a>';
    array_unshift( $links, $settings_link );
  	return $links;
}
$plugin = plugin_basename( __file__ );
add_filter( "plugin_action_links_$plugin", 'gallery_from_files_595_add_settings_link' );

function gallery_from_files_595_styles_and_scripts_to_backend()
{
    global $pagenow;
    
    if (isset($_REQUEST['page'])) {
        $page = sanitize_text_field($_REQUEST['page']);
    } else {
        $page = '';
    }
    // Csak akkor töltődik be, amikor ennek a pluginnak a beállításai aktuálisak.
    if (($pagenow == 'options-general.php') and ($page == 'gallery-from-files-setting-admin')) {

        $tab = 'galleries';
        if (isset($_REQUEST['gallery-from-files-tab'])) { $tab = sanitize_text_field($_REQUEST['gallery-from-files-tab']); }
        if ($tab == 'galleries') {
            wp_enqueue_script('jquery-ui-sortable', '', array('jquery'));
        }

        wp_register_style( 'gallery-from-files-fancybox-css', plugins_url( 'assets/css/fancybox.min.css', __file__ ) );
    	wp_enqueue_style(  'gallery-from-files-fancybox-css' );
        wp_register_script('gallery-from-files-fancybox', plugins_url( 'assets/js/fancybox/fancybox.min.js', __file__ ), array('jquery'), false, true);
        wp_enqueue_script( 'gallery-from-files-fancybox');    


        wp_register_style( 'gallery-from-files-admin', plugins_url( 'assets/css/gallery-from-files-admin.css', __file__ ) );
    	wp_enqueue_style( 'gallery-from-files-admin' );

    	wp_register_script('gallery-from-files-admin-js', plugins_url( 'assets/js/gallery-from-files-admin.js', __file__ ), array('jquery-ui-sortable'));

        wp_register_style( 'image-crop', plugins_url( 'assets/css/jquery.Jcrop.css', __file__ ), false);
        wp_enqueue_style( 'image-crop' );
        wp_register_script('crop-js', plugins_url( 'assets/js/jquery.Jcrop.js', __file__ ), array('jquery'));
    	wp_enqueue_script( 'crop-js');


		// Ajax hívás engedélyezése
		// Enable call ajax
		wp_localize_script('gallery-from-files-admin-js', 'gallery_from_files_595_ajax_object', array( 'ajax_url' => admin_url( 'admin-ajax.php' ) ) );
		$options = gallery_from_files_595_get_options();
		$ajax_vars = array(
				'size'       => $options['size'],
				'th_size'    => $options['th_size'],
				'th_folder'  => $options['th_folder'],
				'page_limit' => $options['page_limit'],
				'order'      => $options['order'],
				'title'      => $options['title'],
				'template'   => $options['template'],
                'url'        => home_url()
			);
		wp_localize_script('gallery-from-files-admin-js', 'gallery_from_files_ajax_vars', $ajax_vars);

        $gallery_lang = array(
                'NEW_FOLDER_LABEL'      => __('New folder name:', 'gallery-from-files'),
                'EDIT_TITLE_LABEL'      => __('Folder new name:', 'gallery-from-files'),
                'NEED_SELECTED_IMAGES'  => __('Is function need selected images!', 'gallery-from-files'),
                'ADD'                   => __('Add'),
                'RENAME'                => __('Rename', 'gallery-from-files'),
                'SELECTED_IMAGES_TITLE' => __('Selected images title:', 'gallery-from-files'),
                'EDIT_IMAGE_TITLE'      => __('Image name:', 'gallery-from-files'),
            );
        $gallery_wait = '<img class="gallery-from-files-wait-image" src="'.plugins_url( 'gallery-from-files/assets/images/wait.gif', GALLERY_FROM_FILES_595_ROOT).'" />';
        $gallery_wait_src = plugins_url( 'gallery-from-files/assets/images/wait.gif', GALLERY_FROM_FILES_595_ROOT);    
		wp_register_script('gallery-from-files-admin-js', '', array('jquery'), false, true);
		wp_localize_script('gallery-from-files-admin-js', 'gallery_lang', $gallery_lang);
		wp_localize_script('gallery-from-files-admin-js', 'gallery_wait', $gallery_wait);
		wp_localize_script('gallery-from-files-admin-js', 'gallery_wait_src', $gallery_wait_src);
		wp_enqueue_script('gallery-from-files-admin-js');
        
    }
}
add_action( 'admin_enqueue_scripts', 'gallery_from_files_595_styles_and_scripts_to_backend' );

include_once(GALLERY_FROM_FILES_595_ROOT .DS. 'libs' .DS. 'frontend-functions.php');    
