<?php

    if ( !defined( 'ABSPATH' ) ) exit;

    class JGalleryFromFiles595 extends stdClass
    {
        private $options         = null;
        private $template_folder = '';
        private $gallery_html    = '';
        private $image_html      = '';
        private $folder_html     = '';
        private $include_images  = false;
        private $include_folders = false;
        private $errorMessage    = array();
        
        public function __construct($options)
        {
            $this->options = $options;
            $this->options['token'] = $this->getToken();

            $validTemplate = false;
            
            if (file_exists(get_stylesheet_directory() .DS. 'gallery-from-files' .DS. $this->options['template'])) {
                $validTemplate = true;
                $this->getCSS(get_stylesheet_directory() .DS. 'gallery-from-files');
                $this->getJS(get_stylesheet_directory() .DS. 'gallery-from-files');
            } else {
                if (file_exists(GALLERY_FROM_FILES_595_ROOT .DS. 'templates' .DS. $this->options['template'])) {
                    $validTemplate = true;
                    $this->getCSS(GALLERY_FROM_FILES_595_ROOT .DS. 'templates');
                    $this->getJS(GALLERY_FROM_FILES_595_ROOT .DS. 'templates');
                }
            }

            // If template _FOLDER_ not found
            if (!$validTemplate) {
                $this->errorMessage[] = 
                    '<div class="gallery-from-files-warning">' . "\r\n" .
                     sprintf( 
                        __('Template folder not exists! <small>(%s)</small>', 'gallery-from-files'), 
                        $this->options['template']) . "\r\n" .
                     '</div>' . "\r\n";
                return false;
            } 

			$ajax_vars = array(
                    'folder'     => $this->options['folder'],
					'order'      => $this->options['order'],
					'template'   => $this->options['template'],
					'th_size'    => $this->options['th_size'],
					'th_folder'  => $this->options['th_folder'],
					'page_limit' => $this->options['page_limit'],
					'title'      => $this->options['title'],
                    'token'      => $this->options['token']
				);

            // Javascript változók átadása
            // Set the javascript values
            if (count($ajax_vars) > 0) {
    			wp_register_script('gallery-from-files-'.$this->options['token'].'-variables-js', '', array('jquery'), false, true);
    			wp_localize_script('gallery-from-files-'.$this->options['token'].'-variables-js', 'gallery_from_files_variables_'.$this->options['token'], $ajax_vars);
    			wp_enqueue_script('gallery-from-files-'.$this->options['token'].'-variables-js');
            }
            
/*            
            $template_folder = explode(DS, $this->options['template']);
            if ($template_folder[0] == 'theme') {
                $temp = $template_folder; 
                unset($temp[0]);
                $template_folder = get_stylesheet_directory() .DS. 'gallery-from-files' .DS. 'templates' .DS. implode(DS, $temp);
            } else {
                $template_folder = WP_PLUGIN_DIR .DS. 'gallery-from-files' .DS. 'templates' .DS. $this->options['template'];
            }
            if (!file_exists($template_folder)) {
                echo '<div class="gallery-from-files-warning">' . "\r\n" .
                     sprintf( 
                        __('Template folder not exists! <small>(%s)</small>', 'gallery-from-files'), 
                        str_replace(ABSPATH, '', $template_folder)) . "\r\n" .
                     '</div>' . "\r\n";
            } else {
                $this->template_folder = $template_folder;
            }

            if (file_exists($this->template_folder .DS. 'gallery.html')) {
                $this->gallery_html = file_get_contents($this->template_folder .DS. 'gallery.html');
            } else {
                echo '<div class="gallery-from-files-warning">' . "\r\n" .
                     sprintf( 
                        __('Template item not exists! <small>(%s)</small>', 'gallery-from-files'), 
                        str_replace(ABSPATH, '', $this->template_folder .DS. 'gallery.html')) . "\r\n" .
                     '</div>' . "\r\n";
                return '';
            }

            // Include images?
            $pos = strpos($this->gallery_html, '[IMAGES]');
            if ($pos !== false) {
                if (file_exists($this->template_folder .DS. 'image.html')) {
                    $this->image_html = file_get_contents($this->template_folder .DS. 'image.html');
                    $this->include_images = true;
                } else {
                    echo '<div class="gallery-from-files-warning">' . "\r\n" .
                         sprintf( 
                            __('Template item not exists! <small>(%s)</small>', 'gallery-from-files'), 
                            str_replace(ABSPATH, '', $this->template_folder .DS. 'image.html')) . "\r\n" .
                         '</div>' . "\r\n";
                }
            }

            // Include folders?
            $pos = strpos($this->gallery_html, '[FOLDERS]');
            if ($pos !== false) {
                if (file_exists($this->template_folder .DS. 'folder.html')) {
                    $this->folder_html = file_get_contents($this->template_folder .DS. 'folder.html');
                    $this->include_folders = true;
                } else {
                    echo '<div class="gallery-from-files-warning">' . "\r\n" .
                         sprintf( 
                            __('Template item not exists! <small>(%s)</small>', 'gallery-from-files'), 
                            str_replace(ABSPATH, '', $this->template_folder .DS. 'folders.html')) . "\r\n" .
                         '</div>' . "\r\n";
                }
            }

            if (!class_exists ('JDovi42Files', false)) {
                include_once(dirname(__file__) .DS. 'jdovi42_files.php');
            }
            $files = new JDovi42Files($this->template_folder);
            $files->allowExt = array('css');
            $css = $files->getFiles();
            if (!empty($css)) {
                $url = str_replace(ABSPATH, '', $this->template_folder);
                for ($i = 0; $i <= count($css)-1; $i++) {
                    wp_register_style( 'gallery-from-files-template-style-'.$i.'-css', DS. $url .DS. $css[$i]['filename'] );
                	wp_enqueue_style(  'gallery-from-files-template-style-'.$i.'-css' );
                }
            }

            
			$ajax_vars = array(
                    'folder'     => $this->options['folder'],
					'order'      => $this->options['order'],
					'template'   => $this->options['template'],
					'th_size'    => $this->options['th_size'],
					'th_folder'  => $this->options['th_folder'],
					'page_limit' => $this->options['page_limit'],
					'title'      => $this->options['title'],
                    'token'      => $this->options['token']
				);

            // Javascript változók átadása
            // Set the javascript values
            if (count($ajax_vars) > 0) {
    			wp_register_script('gallery-from-files-'.$this->options['token'].'-variables-js', '', array('jquery'), false, true);
    			wp_localize_script('gallery-from-files-'.$this->options['token'].'-variables-js', 'gallery_from_files_variables_'.$this->options['token'], $ajax_vars);
    			wp_enqueue_script('gallery-from-files-'.$this->options['token'].'-variables-js');
            }
*/
        }

        private function getToken()
        {
            $chars = 'ABCDEFGHIJKLMNOPQURSTXYVWZ0123456789';
            $token = '';
            for ($i = 1; $i <= 10; $i++) {
            	$token .= substr($chars, rand(0, strlen($chars)-1), 1);
            }                
            return $token;
        }

        function prepareContent()
        {   
            $html = '';
            if (!empty($this->errorMessage)) {
                $html = implode('<br />', $this->errorMessage);
                return $html;
            }

            $image_html = $this->getTemplate('image.html', true);
            if ($image_html != '') {
                $this->image_html = $image_html;
?><pre>
	<?php print_r($this->prepareImages());?>
</pre><?php	
                //$this->prepareImages();
            }
            var_dump($image_html);

            //if ($this->template_folder == '') { return ''; }

            $this->gallery_html = str_replace('[TOKEN]', $this->options['token'], $this->gallery_html);
            $this->gallery_html = str_replace('[FOLDER]', $this->options['folder'], $this->gallery_html);

            $p = explode(DS, $this->options['folder']);
            $name = $p[count($p)-1];
            $this->gallery_html = str_replace('[NAME]', $name, $this->gallery_html);


            $p = explode(DS, $this->options['folder']);
            $name = $p[count($p)-1];
            $this->gallery_html = str_replace('[NAME]', $name, $this->gallery_html);

            if ($this->options['title']) {
            // Get gallery title

                unset($p[count($p)-1]);
                $p = ABSPATH . implode(DS, $p);
                if (!class_exists ('JDovi42Files', false)) {
                    include_once(dirname(__file__) .DS. 'jdovi42_files.php');
                }
                $f = new JDovi42Files($p);
                $title = $f->getTitle($name); 
                $this->gallery_html = str_replace('[TITLE]', $title, $this->gallery_html);

            } else {
                $this->gallery_html = str_replace('[TITLE]', '', $this->gallery_html);
            }     
            
            $images = $this->getImages();
            if (!empty($images)) {

                $count = count($images); 

                $images = array_slice($images, 0, $this->options['page_limit']);
                
                // Get gallery image
                $this->gallery_html = str_replace('[IMAGE]', DS. $this->options['folder'] .DS. $images[0]['filename'], $this->gallery_html);

                // Get gallery thumbnail image
                if (!isset($images[0]['thumbnail'])) {
                    if (!class_exists ('JDovi42Image', false)) {
                        include_once(dirname(__file__) .DS. 'jdovi42_image.php');
                    }
                    $thumbnail = new JDovi42Image(ABSPATH . $this->options['folder'] .DS. $images[0]['filename']);
                    $img->jpeg_compress = $this->options['compress'];
                    if ($this->options['auto'] == 1) {
                        $thumbnail->resizeImage($this->options['size']);
                    }
                    $thumbnail->createThumb($this->options['th_size'], $this->options['th_folder']);
                    $images[0]['thumbnail'] = $this->options['th_folder'] .DS. $images[0]['filename'];
                    if (($this->options['auto'] == 1) and ($this->options['watermark'] != '')) {
                        $thumbnail->watermark['walign'] = 'right';
                        $thumbnail->watermark['halign'] = 'bottom';
                        $thumbnail->createWatermark($this->options['watermark']);
                    }
                    if (isset($options['webp']) and ($options['webp'] == 1)) {
                        $thumbnail->createWebP();
                    }
                    
                }
                $this->gallery_html = str_replace('[THUMBNAIL]', DS. $this->options['folder'] .DS. $images[0]['thumbnail'], $this->gallery_html);

                $images = $this->renderImages($images);
                $this->gallery_html = str_replace('[IMAGES]', $images, $this->gallery_html);
                
                $pagination = $this->getPagination($count, $this->options['page_limit'], 1);
                $this->gallery_html = str_replace('[PAGINATION]', $pagination, $this->gallery_html);

            } else {
                $this->gallery_html = str_replace('[IMAGES]', '', $this->gallery_html);
            }

            $folders = $this->getFolders();
            if (!empty($folders)) {
                
                $folders = $this->renderFolders($folders);
                $this->gallery_html = str_replace('[FOLDERS]', $folders, $this->gallery_html);

            } else {
                $this->gallery_html = str_replace('[FOLDERS]', '', $this->gallery_html);
            }
            
            return $html;
        }

        function prepareImages() 
        {
            $images = $this->getImages();
            if (!empty($images)) {
                $images = $this->getImages();
                $images = $this->renderImages($images);
            }
            
            return $images;
        }


        function getFolders()
        {
            if (!$this->include_folders) { return array(); }

            if (!class_exists ('JDovi42Galleries', false)) {
                include_once(dirname(__file__) .DIRECTORY_SEPARATOR. 'jdovi42_galleries.php');
            }
            $source = new JDovi42Galleries(ABSPATH . $this->options['folder']);
            $folders = $source->getFolders();
            if (empty($folders)) {
                return array();
            }
            
            $url = esc_url( home_url( '/' ) );
            
            for ($i = 0; $i <= count($folders)-1; $i++) {
                if (!isset($folders[$i]['thumbnail'])) {
                    $folders[$i]['thumbnail'] = plugins_url( 'gallery-from-files/assets/css/images/empty-folder.png', GALLERY_FROM_FILES_595_ROOT);
                    $folders[$i]['image'] = $folders[$i]['thumbnail'];
                } else {
                    $pos = strpos($folders[$i]['thumbnail'], $this->options['th_folder']);
                    if ($pos !== false) {
                        $folders[$i]['thumbnail'] = $url . $this->options['folder'] .DS. $folders[$i]['name'] .DS. $folders[$i]['thumbnail'];                     
                        $folders[$i]['image'] = str_replace($this->options['th_folder'] .DS, '', $folders[$i]['thumbnail']);
                    } else {
                        if (!class_exists ('JDovi42Image', false)) {
                            include_once(dirname(__FILE__) .DS. 'jdovi42_image.php');
                        }
                        $folders[$i]['image'] = $url . $this->options['folder'] .DS. $folders[$i]['name'] .DS. $folders[$i]['thumbnail'];
                        $img = new JDovi42Image(ABSPATH . $this->options['folder'] .DS. $folders[$i]['name'] .DS. $folders[$i]['thumbnail']);
                        $img->jpeg_compress = $this->options['compress'];
                        $img->createThumb($this->options['th_size'], $this->options['th_folder']);
                        if (isset($options['webp']) and ($options['webp'] == 1)) {
                            $thumb = new JDovi42Image( ABSPATH . $this->options['folder'] .DS. $folders[$i]['name'] .DS. $this->options['th_folder'] .DS. $folders[$i]['thumbnail'] );
                            $thumb->createWebP();
                        }
                        $folders[$i]['thumbnail'] = $url . $this->options['folder'] .DS. $folders[$i]['name'] .DS. $this->options['th_folder'] .DS. $folders[$i]['thumbnail'];
                    }
                }
            }
            return $folders;
        }

        function renderFolders($source)
        {
            $folders = '';

            if (!empty($source)) {
                
                $size = explode('x', $this->options['th_size']);
                $folders = array();
                
                for ($i = 0; $i <= count($source)-1; $i++) {
                    $folder = $source[$i];
                    $html = $this->folder_html;
                    $html = str_replace('[TOKEN]', $this->options['token'], $html);
                    $html = str_replace('[IMAGE_URL]', $folder['image'], $html);
                    $html = str_replace('[THUMBNAIL_URL]', $folder['thumbnail'], $html);
                    if ($this->options['title']) {
                        if ($folder['title'] != $folder['name']) {
                            $html = str_replace('[TITLE]', $folder['title'], $html);
                        } else {
                            $html = str_replace('[TITLE]', '', $html);
                        }
                    } else {
                        $html = str_replace('[TITLE]', '', $html);
                    }
                    $html = str_replace('[WIDTH]', $size[0], $html);
                    $html = str_replace('[HEIGHT]', $size[1], $html);
                    $html = str_replace('[NAME]', $folder['name'], $html);
                    $html = str_replace('[DATE]', $folder['date'], $html);
                    
                    $pos = strpos($html, '[IMAGES]');
                    if ($pos !== false) {
                        
                        $img_files = array();
                        
                        if (file_exists($this->template_folder .DS. 'folder-images.html')) {
                            $image_html = file_get_contents($this->template_folder .DS. 'folder-images.html');

                            if (!class_exists ('JDovi42Files', false)) {
                                include_once(dirname(__FILE__) .DS. 'jdovi42_files.php');
                            }
                            $img = new JDovi42Files(ABSPATH . $this->options['folder'] .DS. $folder['name']);
                            $img->allowExt = array('jpg', 'png', 'gif');
                            $images = $img->getFiles();
                            if (!empty($images)) {
                                unset($images[0]);
                                foreach ($images as $item) {
                                    $tmp = $image_html;
                                    $tmp = str_replace('[NAME]', $folder['name'], $tmp);
                                    $tmp = str_replace('[TOKEN]', $this->options['token'], $tmp);
                                    $title = '';
                                    if ($this->options['title']) {
                                        if ($item['title'] != $item['filename']) {
                                            $title = $item['title'];
                                        } else {
                                            if (($folder['title'] != '') and ($folder['title'] != $folder['name'])) {
                                                $title = $folder['title'];
                                            }
                                        }
                                    }
                                    $tmp = str_replace('[TITLE]', $title, $tmp);
                                    $tmp = str_replace('[IMAGE_URL]', DS. $this->options['folder'] .DS. $folder['name'] .DS. $item['filename'], $tmp);
                                    
                                    $img_files[] = $tmp;
                                }
                            }
                        } else {
                            echo '<div class="gallery-from-files-warning">' . "\r\n" .
                                 sprintf( 
                                    __('Template item not exists! <small>(%s)</small>', 'gallery-from-files'), 
                                    str_replace(ABSPATH, '', $this->template_folder .DS. 'image.html')) . "\r\n" .
                                 '</div>' . "\r\n";
                        }
                        $images = implode('', $img_files);                        
                        $html = str_replace('[IMAGES]', $images, $html);                         
                    }
                    
                    $folders[] = $html;

                }   
                $folders = implode("\r\n", $folders);             
            }
            
            return $folders;
        }
        
        function getImages()
        {
            if (!class_exists ('JDovi42Galleries', false)) {
                include_once(dirname(__file__) .DIRECTORY_SEPARATOR. 'jdovi42_galleries.php');
            }
            $files = new JDovi42Galleries(ABSPATH . $this->options['folder']);
            $files->allowExt = array('jpg', 'png', 'gif');
            switch ($this->options['order']){ 
            	case 'date':
            	   $files->filesSort = 'sortByDate';
                   $files->filesSortOrder = 'desc';
                   break;
            
            	case 'name':
            	   $files->filesSort = 'sortByName';
                   $files->filesSortOrder = 'asc';
                   break;
            
            	default :
            	   $files->filesSort = 'sortByList';
                   $files->filesSortOrder = 'asc';
            }
            $images = $files->getFiles();
            
            if (isset($this->options['max'])) {
                $images = array_slice($images, 0, $this->options['max']);
            }
            
            return $images;            
        }

        function renderImages($source)
        {
            $images = '';
            $size = explode('x', $this->options['th_size']);
            
            $url = esc_url( home_url( '/' ) );
            
            if (!empty($source)) {
                $images = array();
                for ($i = 0; $i <= count($source)-1; $i++) {
                    $img = $source[$i];
                    $html = $this->image_html;
                    
                    // Ha nincs generált bélyegkép, akkor csinálunk
                    if (!isset($img['thumbnail'])) {
                        if (!class_exists ('JDovi42Image', false)) {
                            include_once(dirname(__file__) .DIRECTORY_SEPARATOR. 'jdovi42_image.php');
                        }
                        $thumbnail = new JDovi42Image(ABSPATH . $this->options['folder'] .DS. $img['filename']);
                        $img->jpeg_compress = $this->options['compress'];
                        
                        if ($this->options['auto'] == 1) {
                            $thumbnail->resizeImage($this->options['size']);
                        }
                        $thumbnail->createThumb($this->options['th_size'], $this->options['th_folder']);
                        if (isset($options['webp']) and ($options['webp'] == 1)) {
                            $thumb = new JDovi42Image( ABSPATH . $this->options['folder'] .DS. $this->options['th_folder'] .DS. $folders[$i]['thumbnail'] );
                            $thumb->createWebP();
                        }
                        
                        $img['thumbnail'] = $this->options['th_folder'] .DS. $img['filename'];

                        if (($this->options['auto'] == 1) and ($this->options['watermark'] != '')) {
                            $thumbnail->watermark['walign'] = 'right';
                            $thumbnail->watermark['halign'] = 'bottom';
                            
                            $upload = wp_get_upload_dir();
                            if (file_exists($upload['basedir'] .DS. $this->options['watermark'])) {
                                $thumbnail->createWatermark($upload['basedir'] .DS. $this->options['watermark']);
                            }
                        }
                    }
                    
                    $html = str_replace('[TOKEN]', $this->options['token'], $html);
                    $html = str_replace('[IMAGE_URL]', $url . $this->options['folder'] .DS. $img['filename'], $html);
                    $html = str_replace('[THUMBNAIL_URL]', $url . $this->options['folder'] .DS. $img['thumbnail'], $html);
                    if ($this->options['title']) {
                        if ($img['title'] != $img['filename']) {
                            $html = str_replace('[TITLE]', $img['title'], $html);
                        } else {
                            $html = str_replace('[TITLE]', '', $html);
                        }
                    } else {
                        $html = str_replace('[TITLE]', '', $html);
                    }
                    $html = str_replace('[WIDTH]', $size[0], $html);
                    $html = str_replace('[HEIGHT]', $size[1], $html);
                    $html = str_replace('[NAME]', $img['name'], $html);
                    $html = str_replace('[ALIAS]', $img['alias'], $html);
                    $html = str_replace('[EXT]', $img['ext'], $html);
                    $html = str_replace('[SIZE]', $img['size'], $html);
                    $html = str_replace('[DATE]', $img['date'], $html);
                    $images[] = $html;
                }
                $images = implode("\r\n", $images);
            }
            return $images;
        }
        
        function getPagination($count, $limit, $actual)
        {
            $html = '';
            if ((isset($this->options['pagination'])) and ($this->options['pagination'] == 0)) {
                return '';
            }
            if ($count > $limit) {
                $pages = ceil($count / $limit);
                
                $html .= '<ul class="gallery-from-files-pagination" data-token="'.$this->options['token'].'"  data-actual="1">' . "\r\n";
                for ($i = 1; $i <= $pages; $i++) {
                    if ($i == $actual) {
                        $current = 'current';
                    } else {
                        $current = '';
                    }
                    $html .= '<li class="gallery-from-files-page-item"><span id="'.$this->options['token'].'_gallery_pagination_item_'.$i.'" class="gallery-from-files-page-link '.$current.'" onclick="gallery_from_files_595_get_page(\''.$i.'\', jQuery(this));">'.$i.'</span></li>' . "\r\n";
                }
                $html .= '</ul>' . "\r\n" . 
                         '<div style="clear:both;"></div>' . "\r\n";
            }
            return $html;            
        }

        function getTemplate($filename, $silent = false) {

            $template = '';
            if (file_exists(get_stylesheet_directory() .DS. 'gallery-from-files' .DS. $this->options['template'] .DS. $filename)) {
                $template = file_get_contents(get_stylesheet_directory() .DS. 'gallery-from-files' .DS. $this->options['template'] .DS. $filename);
            } else {
                if (file_exists(GALLERY_FROM_FILES_595_ROOT .DS. 'templates' .DS. $this->options['template'] .DS. $filename)) {
                    $template = file_get_contents(GALLERY_FROM_FILES_595_ROOT .DS. 'templates' .DS. $this->options['template'] .DS. $filename);
                } else {
                    if (!$silent) {
                        echo $this->showError(
                                __('Template file not exists! <small>(%s)</small>', 'gallery-from-files'),
                                $filename
                            );
                    }
                    return '';
                }
            }
            return $template;
        }
        
        function getCSS($source)
        {
            // CSS fájlok beolvasása, ha vannak
            if (!class_exists ('JDovi42Files', false)) {
                include_once(dirname(__file__) .DS. 'jdovi42_files.php');
            }
            $files = new JDovi42Files($source .DS. $this->options['template']);
            $files->allowExt = array('css');
            $css = $files->getFiles();
            
            if (!empty($css)) {
                $url = esc_url( home_url( '/' ) );
                $url = $url . str_replace(ABSPATH, '', $source) .DS. $this->options['template'];
                for ($i = 0; $i <= count($css)-1; $i++) {
                    wp_register_style( 'massage-gallery-style-'.$this->options['template'].'-'.$i, $url .DS. $css[$i]['filename'] );
                	wp_enqueue_style(  'massage-gallery-style-'.$this->options['template'].'-'.$i );
                }
            }
            
        }

        function getJS($source)
        {
            if (!class_exists ('JDovi42Files', false)) {
                include_once(dirname(__file__) .DS. 'jdovi42_files.php');
            }
            $files = new JDovi42Files($source .DS. $this->options['template']);
            $files->allowExt = array('js');
            $js = $files->getFiles();
            if (!empty($js)) {
                $url = esc_url( home_url( '/' ) );
                $url = $url . str_replace(ABSPATH, '', $source) .DS. $this->options['template'];
                for ($i = 0; $i <= count($js)-1; $i++) {
        			wp_register_script('massage-gallery-js-'.$this->options['template'].'-'.$i, $url .DS. $js[$i]['filename'] );  
        			wp_enqueue_script('massage-gallery-js-'.$this->options['template'].'-'.$i);
                }
            }
        }
        
    }