<?php
function include_gallery_from_files_595_media_button_js_file() {
    global $pagenow;
    $options = gallery_from_files_595_get_options();
    if ( in_array( $pagenow, array( 'post.php', 'page.php', 'post-new.php', 'post-edit.php' ) ) ) {
        wp_enqueue_style( 'dovi_gallery_admin_tree', plugins_url( 'gallery-from-files/assets/css/jstree.style.css', GALLERY_FROM_FILES_595_ROOT), false, '1.0.0' );
        wp_enqueue_style( 'gallery-from-files-tree-css', plugins_url( 'gallery-from-files/assets/css/gallery-tree.css', GALLERY_FROM_FILES_595_ROOT), false, '1.0.0' );
                
        wp_register_script('gallery-from-files-tree-js', plugins_url( 'gallery-from-files/assets/js/gallery-media-button.js', GALLERY_FROM_FILES_595_ROOT ), array('jquery'), false, true);
        wp_enqueue_script('gallery-from-files-media-button-js', plugins_url( 'gallery-from-files/assets/js/jstree.js', GALLERY_FROM_FILES_595_ROOT ), array('gallery-from-files-tree-js'), '1.0', true);
        wp_localize_script('gallery-from-files-media-button-js', 'plugin_url', plugins_url( 'gallery-from-files/libs/gallery-load.php', GALLERY_FROM_FILES_595_ROOT ));
        wp_localize_script('gallery-from-files-media-button-js', 'thumb_dir', $options['th_folder']);
        wp_localize_script('gallery-from-files-media-button-js', 'ABSPATH', ABSPATH);
    }
}
add_action('wp_enqueue_media', 'include_gallery_from_files_595_media_button_js_file');

function add_gallery_from_files_595_media_button() {
    global $pagenow;
    if ( in_array( $pagenow, array( 'post.php', 'page.php', 'post-new.php', 'post-edit.php' ) ) ) {

        $html = '<a href="#TB_inline?&width=754&height=560&inlineId=gallery-from-files-tree-block" class="thickbox button" title="' .
                __( "Select gallery from folders to insert into post", "gallery-from-files" ) .
                '"><span class="wp-media-buttons-icon dashicons dashicons-images-alt2"></span> ' .
                __('File gallery', 'gallery-from-files') . '</a>';
        echo $html;
    }
}
add_filter('media_buttons', 'add_gallery_from_files_595_media_button');

function gallery_from_files_595_admin_footer()
{
    global $pagenow;
    if ( in_array( $pagenow, array( 'post.php', 'page.php', 'post-new.php', 'post-edit.php' ) ) ) {
        $options = gallery_from_files_595_get_options();
         ?>
        <div id="gallery-from-files-tree-block" style="display: none;">
            <div id="gallery_from_files_tree" data-path="/" > 
            </div>             
            <div class="gallery-insert-functions">
                <table cellpadding="6" style="width:100%;">
                    <tr>
                        <td>
                            <?php _e('Order', 'gallery-from-files');?>
                            <select id="gallery_from_files_sort">
                                <option value="set"><?php _e('set_title', 'gallery-from-files');?></option>
                                <option value="name"><?php _e('name_title', 'gallery-from-files');?></option>
                                <option value="date"><?php _e('date_title', 'gallery-from-files');?></option>
                            </select>
                        </td>
                        <td>
                            <?php
                                if (!class_exists('JDovi42Files')) {
                                    include_once( dirname(__file__) .DS. 'jdovi42_files.php');
                                }
                                $files = new JDovi42Files(GALLERY_FROM_FILES_595_ROOT .DS. 'templates'); 
                                $files->addTilt('sample');
                                $files->folderSort = 'sortByName';
                                $tmp = $files->getFolders();

                                $templates = array();
                                foreach ($tmp as $item) {
                                    $templates[$item['filename']] = $item['title'];
                                }

                                if (is_dir(get_stylesheet_directory() .DS. 'gallery-from-files')) {
                                    $files = new JDovi42Files(get_stylesheet_directory() .DS. 'gallery-from-files');
                                    $files->folderSort = 'sortByName';
                                    $in_themes = $files->getFolders();

                                    foreach ($in_themes as $theme) {
                                        if (!in_array($theme['filename'], $templates)) {
                                            $templates[$theme['filename']] = $theme['title'];
                                        }
                                    }        
                                }
                                $selected = isset( $options['template'] ) ? esc_attr( $options['template']) : '';
                                _e('Template', 'gallery-from-files');
                                echo '&nbsp;<select id="gallery_from_template" name="gallery_from_template">';
                                foreach ($templates as $key => $value) {
                                    echo '<option value="'.$key.'" '.selected( $selected, $key ).'>'.$value.'</option>';
                                }        
                                echo '</select>'; 
                            ?>
                        </td>
                        <td>
                            <?php _e('Page limit', 'gallery-from-files');?>
                            <input type="text" id="gallery_from_files_images_count" value="<?php echo $options['page_limit'];?>" style="width:40px;" />
                        </td>
                        <td>
                            <input type="checkbox" id="use_title" value="1" checked="checked" />
                            <small><?php echo __('Use title', 'gallery-from-files');?></small>                        
                        </td>
                    </tr>
                </table>
            </div>
            <div style="text-align: center;margin-top: 10px;">
                <button class="button secondary" id="cancelFileGallery"><?php echo __( "Cancel", "gallery-from-files" );?></button>
                <button class="button primary" id="insertFileGallery" disabled="disabled"><?php echo __( "Insert gallery", "gallery-from-files" );?></button>
            </div>
        </div>
        <?php
    }
}
add_action('admin_footer', 'gallery_from_files_595_admin_footer', 11);
