<?php
/**
 * @version   1.0 
 * @author    Dovi42 
 * @home      http://dovi42.hu/
 * @package   Galleries library
 * @license   All Rights Reserved - Minden jog fenntartva
 * @copyright (C) 2020 Dovalovszki Tamás - All rights reserved.
 **/

/* 
    Use:
    if (!class_exists ('JDovi42Galleries', false)) {
       include_once(dirname(__FILE__) .DS. 'jdovi42_galleries.php');
    }
    $source  = new JDovi42Galleries('<absolute_path>');
    $folders = $source->getFolders();
    $files   = $source->getFiles();
*/

    if (!defined('DS')) { define( 'DS', DIRECTORY_SEPARATOR ); }
    
    include_once( dirname(__file__) .DS. 'jdovi42_files.php');
    

class JDovi42Galleries extends JDovi42Files
{
    private $thumbnail_folder = '';    
    public $allowExt          = array('jpg', 'png', 'gif');

	public function __construct($path = null, $thumbnail_folder = '_thumbs')
	{
        parent::__construct($path);
        $this->thumbnail_folder = $thumbnail_folder;
        $this->addTilt($thumbnail_folder);
    }    
    
    function getFolders()
    {
        parent::getFolders();
        
        if (!empty($this->folders)) {
            for ($i = 0; $i <= count($this->folders)-1; $i++) {
                $tmp = new JDovi42Files($this->path .DS. $this->folders[$i]['filename']);
                $tmp->allowExt = $this->allowExt;
                $images = $tmp->getFiles();	
                if (!empty($images)) {
                    if (file_exists($this->path .DS. $this->folders[$i]['filename'] .DS. $this->thumbnail_folder .DS. $images[0]['filename'])) {
                        $this->folders[$i]['thumbnail'] = $this->thumbnail_folder .DS. $images[0]['filename'];
                    } else {
                        $this->folders[$i]['thumbnail'] = $images[0]['filename'];                    
                    }
                }
            }
        }        
        return $this->folders;
    }

    function getFiles()
    {
        parent::getFiles();

        if (!empty($this->files)) {
            for ($i = 0; $i <= count($this->files)-1; $i++) {
                if (file_exists($this->path .DS. $this->thumbnail_folder .DS. $this->files[$i]['filename'])) {
                    $this->files[$i]['thumbnail'] = $this->thumbnail_folder .DS. $this->files[$i]['filename'];
                }
            }        
        }
        return $this->files;
    }
    
}
    